;-----------------------------------------------------
; sample2.asm - Copyright (C) Mikael Sundberg 1999
;-----------------------------------------------------

	include "savelib.h"
	include "doorsos.h"
	include "userlib.h"
	include "graphlib.h"

	xdef _main
	xdef _comment
	xdef _ti89

;-----------------------------------------------------
; Main
;-----------------------------------------------------

_main:	; @@ Load data from file using savelib
	; @@ The name of the file the data will be loaded 
	; @@ from is pointed to by <sl_name>. Data will be 
	; @@ written to memory that starts at <sl_start> and 
	; @@ ends at <sl_end>.

	savelib::eloadm sl_name,sl_start,sl_end
	
	; @@ Check if something was loaded, if it was bit 0 
	; @@ in d0 will be 1 else it will be 0

	btst	#0,d0				; Check result
	bne	\loaded				; Jump to loaded if OK
	
	; @@ Error occured, probably the file wasn't found (error code is in d1.w)
	; @@ Set string to "-" (If we don't set it, it could be filled with trash)
	
	move.b	#45,(string)			; Clear string (set it to "-")
	move.b	#0,(string+1)			; ..

\loaded	jsr	graphlib::clr_scr		; Clear screen
	
	SetFont #1				; Set font..
	
	WriteStrA #30,#25,#2,#string		; Display string
	
	move.w	#30,d1				; X-pos
	move.w	#65,d2				; Y-pos
	move.w	#10,d3				; Maxlength of text
	
	jsr	userlib::InputStr		; Read text
		
	cmp	#0,d0				; Check if something was read
	beq	\skip
	
	move.w	#10,d0				; Copy data read to string
	lea	string,a1				; ..
\loop	move.b	(a0)+,(a1)+			; ..
	dbra	d0,\loop			; ..

	; @@ Save data to file using savelib
	; @@ The name of the file the data will be saved 
	; @@ to is pointed to by <sl_name>. Data will be 
	; @@ read from memory that starts at <sl_start> and 
	; @@ ends at <sl_end>.

\skip	savelib::esavem sl_name,sl_start,sl_end
	
	rts

;-----------------------------------------------------
; Program comment
;-----------------------------------------------------

_comment dc.b "Savelib sample 2",0
	
;-----------------------------------------------------
; Variables
;-----------------------------------------------------

sl_name	dc.b "sample2",0			; @@ Filename used by savelib

sl_start					; @@ Savelib starts reading/writing data here
string	dc.b "ABCDEFGHIJ",0			; @@ String that will be saved
sl_end						; @@ Savelib ends reading/writing data here

	end